package fr.feufochmar.scribbly;

import java.util.ArrayList;
import java.util.List;

/**
 * A Scribbly document. A Scribbly document is made of elements which can be either text or commands.
 * @author Feufochmar
 *
 */
public class ScribblyDocument
{
  /**
   * Elements of the document
   */
  private final List<ScribblyElement> m_elements = new ArrayList<ScribblyElement>();
  
  /**
   * Constructor
   */
  public ScribblyDocument()
  {
  }
  
  /**
   * Add an element to the document.
   * @param elem
   */
  public void addElement(ScribblyElement elem)
  {
    m_elements.add(elem);
  }
  
  /**
   * Get the elements of the document.
   * @return
   */
  public List<ScribblyElement> elements()
  {
    return m_elements;
  }
  
  /**
   * Visitor pattern method.
   * @param visitor
   */
  public void visit(ScribblyVisitor visitor)
  {
    visitor.onBeginDocument(this);
    for (ScribblyElement elem: m_elements)
    {
      elem.visit(visitor);
    }
    visitor.onEndDocument(this);
  }
}
